using System;
using System.ComponentModel;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Xml.Serialization;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Utilities;
using Microsoft.SharePoint.WebPartPages;

using System.Web;
using System.Drawing;
using System.Security.Principal;
using System.Web.UI.HtmlControls;
using System.DirectoryServices;

namespace Powerise.YoungSem.AD.ChangeMyPassWord
{
	/// <summary>
	/// Description for WebPart1.
	/// </summary>
//	[DefaultProperty("Text"),
//		ToolboxData("<{0}:ChangePassword runat=server></{0}:ChangePassword>"),
//		XmlRoot(Namespace="Powerise.YoungSem.AD.ChangeMyPassWord")]
	[ToolboxData("<{0}:ChangePassword runat=server></{0}:ChangePassword>"), XmlRoot(Namespace="Powerise.YoungSem.AD.ChangeMyPassWord")]
	public class ChangePassword : Microsoft.SharePoint.WebPartPages.WebPart
	{	
		#region Fields

		private string _fqdn;
		private bool _showFullErrorMsgs;
		private Table _table;

		private string _newPassword;
		private string _newPasswordConfirm;
		private string _oldPassword;
		private string _username;
		private Button btnChangePassword;
		private Label lblAccount;
		private Label lblAccountName;
		private Label lblCopyright;
		private Label lblError;
		private Label lblNewPassword;
		private Label lblNewPasswordConfirm;
		private Label lblOldPassword;
		private Label lblSuccess;
		private Panel pnlError;
		private Panel pnlSuccess;
		private TextBox tbNewPassword;
		private TextBox tbNewPasswordConfirm;
		private TextBox tbOldPassword;

		private const string c_btn_change_password = "޸";
		private const string c_copyright = "Powerise - <br/>Copyright 2000 - 2006 by <b><a href=\"http://www.powerise.com.cn\">Powerise</a></b>";
		private const string c_err_authentication_failed = ": .";
		private const string c_err_cant_change_passwort = ": .";
		private const string c_err_fillform = ": дϢ.";
		private const string c_err_passwords_not_equal = ": ȷͬ.";
		private const string c_err_settings_not_set = "<div style='padding:6px;'><a href=\"{0}\"></a> <b></b></div><br>";
		private const string c_err_user_not_found = ": ûû.";
		private const string c_logonas = "ǰ¼û";
		private const string c_new_password = ":";
		private const string c_new_password_confirm = "ȷ:";
		private const string c_old_password = "ԭ:";
		private const string c_success_msg = "ĳɹ.";

		#endregion

		#region Properties

		[Category("")]
		[DefaultValue("PORT.net")] // There are some bugs here need to be fixed.
		[WebPartStorage(Storage.Personal)]
		[FriendlyNameAttribute("")]
		[Description(".")]
		[Browsable(true)]
		[XmlElement(ElementName="Fqdn")]
		public string Fqdn
		{
			get
			{
				return this._fqdn;
			}
			set
			{
				this._fqdn = value;
			}
		}
		
		[Category("")]
		[DefaultValue(true)]
		[WebPartStorage(Storage.Personal)]
		[FriendlyNameAttribute("ʾϸ")]
		[Description("Ƿʾϸ.")]
		[Browsable(true)]
		[XmlElement(ElementName="ShowFullErrors")]
		public bool ShowFullErrors
		{
			get
			{
				return this._showFullErrorMsgs;
			}
			set
			{
				this._showFullErrorMsgs = value;
			}
		}

		#endregion

		#region Public Methods

		public ChangePassword()
		{
			this._username = string.Empty;
			this._newPassword = string.Empty;
			this._newPasswordConfirm = string.Empty;
			this._oldPassword = string.Empty;
			this._table = new Table();
			this.lblAccount = new Label();
			this.lblAccountName = new Label();
			this.lblCopyright = new Label();
			this.lblError = new Label();
			this.lblNewPasswordConfirm = new Label();
			this.lblNewPassword = new Label();
			this.lblOldPassword = new Label();
			this.lblSuccess = new Label();
			this.tbNewPassword = new TextBox();
			this.tbNewPasswordConfirm = new TextBox();
			this.tbOldPassword = new TextBox();
			this.pnlError = new Panel();
			this.pnlSuccess = new Panel();
			this.btnChangePassword = new Button();
			this._showFullErrorMsgs = true;
			this._fqdn = string.Empty;
		}

		#endregion

		#region Protected Methods

		public override ToolPart[] GetToolParts()
		{
			ToolPart[] partArray1 = new ToolPart[3];
			WebPartToolPart part1 = new WebPartToolPart();
			CustomPropertyToolPart part2 = new CustomPropertyToolPart();
			partArray1[0] = part1;
			partArray1[1] = new Copyright();
			partArray1[2] = part2;
			return partArray1;
		}

		protected override void CreateChildControls()
		{
			try
			{
				this.SetProperties();
				this.GetUserData();
				this.GenerateForm();
				base.CreateChildControls();
				this.Controls.Add(this._table);
			}
			catch (Exception exception1)
			{
				HttpContext.Current.Response.Write(exception1.Message);
			}
		}


		/// <summary>
		/// Render this Web Part to the output parameter specified.
		/// </summary>
		/// <param name="output"> The HTML writer to write out to </param>
		protected override void RenderWebPart(HtmlTextWriter output)
		{
			try
			{
				if ((this.Fqdn == string.Empty) || !this.CheckFqdnName())
				{
					string text1 = ToolPane.GetShowToolPaneEvent(this, ToolPane.ToolPaneView.Properties);
					output.Write("<div style='padding:6px;'><a href=\"{0}\"></a> <b></b></div><br>", text1);
				}
				else
				{
					this.EnsureChildControls();
					RenderChildren( output );
//					this._table.RenderControl(output);
				}
			}
			catch (Exception exception1)
			{
				throw exception1;
			}
		}

		#endregion

		#region private methods

		private bool CheckFqdnName()
		{
			bool flag1 = false;
			int num1 = this._fqdn.IndexOf(".");
			if (num1 != -1)
			{
				flag1 = true;
			}
			return flag1;
		}

		private void SetProperties()
		{
			int num1 = 160;
			this.tbNewPassword.Width = Unit.Pixel(num1);
			this.tbNewPassword.TextMode = TextBoxMode.Password;
			this.tbNewPasswordConfirm.Width = Unit.Pixel(num1);
			this.tbNewPasswordConfirm.TextMode = TextBoxMode.Password;
			this.tbOldPassword.Width = Unit.Pixel(num1);
			this.tbOldPassword.TextMode = TextBoxMode.Password;
			this.btnChangePassword.Width = Unit.Pixel(num1);
			this.lblAccountName.Font.Bold = true;
			this.lblAccount.Text = "ǰ¼û";
			this.lblNewPassword.Text = ":";
			this.lblNewPasswordConfirm.Text = "ȷ:";
			this.lblOldPassword.Text = "ԭ:";
			this.lblError.Font.Bold = true;
			this.lblSuccess.Text = "ĳɹ.";
			this.lblSuccess.Font.Bold = true;
			this.lblCopyright.Text = "Powerise - <br/>Copyright 2000 - 2006 by <b><a href=\"http://www.powerise.com.cn\">Powerise</a></b>";
			this.lblCopyright.Font.Size = FontUnit.Point(7);
			this.lblCopyright.ForeColor = Color.FromName("#a1a1a1");
			this.pnlError.ForeColor = Color.Red;
			this.pnlError.Style.Add("padding-top", "10px");
			this.pnlError.Visible = false;
			this.pnlSuccess.ForeColor = Color.Green;
			this.pnlSuccess.Style.Add("padding-top", "10px");
			this.pnlSuccess.Visible = false;
			this.btnChangePassword.Text = "޸";
			this.btnChangePassword.Style.Add("margin-bottom", "4px");
			this.btnChangePassword.Click += new EventHandler(this.btnChangePassword_Click);
			this._table.Width = Unit.Percentage(100);
			this._table.CellPadding = 0;
			this._table.CellSpacing = 0;
		}

		private void btnChangePassword_Click(object sender, EventArgs e)
		{
			try
			{
				this._oldPassword = this.tbOldPassword.Text;
				this._newPassword = this.tbNewPassword.Text;
				this._newPasswordConfirm = this.tbNewPasswordConfirm.Text;
				this.CheckBoxesFilled();
				this.ComparePasswords();
				this.ChangeAdPassword();
				this.pnlError.Visible = false;
				this.pnlSuccess.Visible = true;
				this.lblSuccess.Text = "ĳɹ.";
			}
			catch (Exception exception1)
			{
				this.lblError.Text = exception1.Message;
				this.pnlError.Visible = true;
				this.pnlSuccess.Visible = false;
				if ((exception1.InnerException != null) && this.ShowFullErrors)
				{
					this.lblError.Text = this.lblError.Text + "<br/>[" + exception1.InnerException.Message + "]";
				}
			}
		}

		private void CheckBoxesFilled()
		{
			if (((this.tbNewPassword.Text.Length == 0) || (this.tbNewPasswordConfirm.Text.Length == 0)) || (this.tbOldPassword.Text.Length == 0))
			{
				throw new Exception(": дϢ.");
			}
		}

		private void ComparePasswords()
		{
			if (string.Compare(this.tbNewPassword.Text, this.tbNewPasswordConfirm.Text) != 0)
			{
				throw new Exception(": ȷͬ.");
			}
		}

		private void ChangeAdPassword()
		{
			string text1 = string.Empty;
			try
			{
				SearchResult result1;
				try
				{
					string[] textArray1 = this.Fqdn.Split(new char[] { '.' });
					string[] textArray2 = textArray1;
					for (int num1 = 0; num1 < textArray2.Length; num1++)
					{
						string text2 = textArray2[num1];
						text1 = text1 + "dc=" + text2 + ",";
					}
					text1 = text1.Remove(text1.Length - 1, 1);
				}
				catch
				{
					throw new FqdnException();
				}
				try
				{
					DirectoryEntry entry1 = new DirectoryEntry("LDAP://" + text1, this._username, this.tbOldPassword.Text);
					DirectorySearcher searcher1 = new DirectorySearcher(entry1);
					searcher1.Filter = "(samAccountName=" + this._username + ")";
					result1 = searcher1.FindOne();
				}
				catch
				{
					throw new LogonException();
				}
				if (result1 == null)
				{
					throw new UserNotFoundException();
				}
				DirectoryEntry entry2 = result1.GetDirectoryEntry();
				entry2.Invoke("ChangePassword", new object[] { this.tbOldPassword.Text, this.tbNewPassword.Text });
				entry2.CommitChanges();
			}
			catch (UserNotFoundException)
			{
				throw new Exception(":ûû.");
			}
			catch (LogonException)
			{
				throw new Exception(": .");
			}
			catch (Exception exception1)
			{
				if (exception1.InnerException != null)
				{
					throw new Exception(": ʧ.", exception1.InnerException);
				}
				throw new Exception(": ʧ.", exception1);
			}
		}

		private void GetUserData()
		{
			string text1 = WindowsIdentity.GetCurrent().Name;
			int num1 = text1.IndexOf(@"\") + 1;
			this._username = text1.Substring(num1, text1.Length - num1);
			this.lblAccountName.Text = text1;
		}

		private void GenerateForm()
		{
			TableRow row1 = new TableRow();
			TableCell cell1 = new TableCell();
			cell1.Controls.Add(this.GenerateErrorForm());
			row1.Cells.Add(cell1);
			this._table.Rows.Add(row1);
			row1 = new TableRow();
			cell1 = new TableCell();
			cell1.Controls.Add(this.GenerateContentForm());
			row1.Cells.Add(cell1);
			this._table.Rows.Add(row1);
			row1 = new TableRow();
			cell1 = new TableCell();
			HtmlImage image1 = new HtmlImage();
			image1.Src = "/_layouts/images/blank.gif";
			image1.Height = 1;
			image1.Width = 1;
			cell1.BackColor = Color.FromName("#ebebeb");
			cell1.Controls.Add(image1);
			row1.Cells.Add(cell1);
			this._table.Rows.Add(row1);
			row1 = new TableRow();
			cell1 = new TableCell();
			cell1.HorizontalAlign = HorizontalAlign.Left;
			cell1.Controls.Add(this.GenerateCopyrightForm());
			row1.Cells.Add(cell1);
			this._table.Rows.Add(row1);
		}

		private Table GenerateErrorForm()
		{
			Table table1 = new Table();
			TableRow row1 = new TableRow();
			TableCell cell1 = new TableCell();
			this.pnlSuccess.Controls.Add(this.lblSuccess);
			this.pnlError.Controls.Add(this.lblError);
			cell1.Controls.Add(this.pnlSuccess);
			cell1.Controls.Add(this.pnlError);
			row1.Cells.Add(cell1);
			table1.Rows.Add(row1);
			return table1;
		}

		private Table GenerateContentForm()
		{
			Table table1 = new Table();
			Table table2 = new Table();
			table2.Width = Unit.Pixel(140);
			TableRow row1 = new TableRow();
			TableCell cell1 = new TableCell();
			cell1.Controls.Add(table2);
			TableCell cell2 = new TableCell();
			row1.Cells.Add(cell1);
			row1.Cells.Add(cell2);
			table1.Rows.Add(row1);
			row1 = new TableRow();
			cell1 = new TableCell();
			cell1.Height = Unit.Pixel(0x16);
			cell1.Controls.Add(this.lblAccount);
			cell2 = new TableCell();
			cell2.Controls.Add(this.lblAccountName);
			row1.Cells.Add(cell1);
			row1.Cells.Add(cell2);
			table1.Rows.Add(row1);
			row1 = new TableRow();
			cell1 = new TableCell();
			cell1.Controls.Add(this.lblOldPassword);
			cell2 = new TableCell();
			cell2.Controls.Add(this.tbOldPassword);
			row1.Cells.Add(cell1);
			row1.Cells.Add(cell2);
			table1.Rows.Add(row1);
			row1 = new TableRow();
			cell1 = new TableCell();
			cell1.Controls.Add(this.lblNewPassword);
			cell2 = new TableCell();
			cell2.Controls.Add(this.tbNewPassword);
			row1.Cells.Add(cell1);
			row1.Cells.Add(cell2);
			table1.Rows.Add(row1);
			row1 = new TableRow();
			cell1 = new TableCell();
			cell1.Controls.Add(this.lblNewPasswordConfirm);
			cell2 = new TableCell();
			cell2.Controls.Add(this.tbNewPasswordConfirm);
			row1.Cells.Add(cell1);
			row1.Cells.Add(cell2);
			table1.Rows.Add(row1);
			row1 = new TableRow();
			cell1 = new TableCell();
			cell2 = new TableCell();
			cell2.Controls.Add(this.btnChangePassword);
			row1.Cells.Add(cell1);
			row1.Cells.Add(cell2);
			table1.Rows.Add(row1);
			return table1;
		}

		private Table GenerateCopyrightForm()
		{
			Table table1 = new Table();
			table1.Width = Unit.Pixel(300);
			TableRow row1 = new TableRow();
			TableCell cell1 = new TableCell();
			cell1.HorizontalAlign = HorizontalAlign.Center;
			cell1.Style.Add("padding-top", "6px");
			cell1.Controls.Add(this.lblCopyright);
			row1.Cells.Add(cell1);
			table1.Rows.Add(row1);
			return table1;
		}

		#endregion
	}

	#region Exception Class

	public class FqdnException : Exception
	{
		// Methods
		public FqdnException()
		{
		}
	}

	public class LogonException : Exception
	{
		// Methods
		public LogonException()
		{
		}
	}

	public class UserNotFoundException : Exception
	{
		// Methods
		public UserNotFoundException()
		{
		}
	}

	#endregion

	#region Copyright Class

	public class Copyright : ToolPart
	{
		// Methods
		public Copyright()
		{
			base.Title = "Powerise - ";
		}

		public override void ApplyChanges()
		{
		}

		public override void CancelChanges()
		{
		}

		protected override void RenderToolPart(HtmlTextWriter output)
		{
			output.Write("Powerise - <br/>Copyright 2000 - 2006 by <b><a href=\"http://www.powerise.com.cn\">Powerise</a></b>");
		}

		public override void SyncChanges()
		{
		}

		#endregion
	}
}
